<?php
require_once(__DIR__ . "/lib/core.inc.php");
die("NOTHING HERE YET");

$_q = "SELECT hour, avg_hallenbad, avg_sommerbad FROM v_stats_overall;";
$totalData = Database::getLink()->get($_q);

$_q = "SELECT dow FROM `v_daysOfWeek`";
$daysOfWeek = Database::getLink()->get($_q);

$dayOfWeekData = [];
foreach ($daysOfWeek as $dayOfWeek) {
	$_q = "SELECT hour, avg_sommerbad, avg_hallenbad FROM `v_stats_by_day` WHERE dayOfWeek=$dayOfWeek[dayOfWeek];";
	$t = [];
	foreach (Database::getLink()->get($_q) as $u) {
		$t[] = "['$u[hour] Uhr', $u[avg_sommerbad], $u[avg_hallenbad]],";
	}

	$dayOfWeekData[$dayOfWeek['dayOfWeek']] = $t;
}


///last 4 hours linechart data
$_q = "SELECT date, hallenbad, sommerbad FROM besucher WHERE date >= '" . date("Y-m-d 00:00:00") . "' ORDER BY recordId ASC;";
$last4h_s = Database::getLink()->get($_q);
$last4h = [];
foreach ($last4h_s as $lh)
	$last4h[] = "[ '" . $lh["date"] . "', " . $lh["sommerbad"] . ", " . $lh["hallenbad"] . " ]";


function dayIntToName(int $dayOfWekkNumber)
{
	switch ($dayOfWekkNumber) {
		case 0:
		case 7:
			return "Sonntag";
		case 1:
			return "Montag";
		case 2:
			return "Dienstag";
		case 3:
			return "Mittwoch";
		case 4:
			return "Donenrstag";
		case 5:
			return "Freitag";
		case 6:
			return "Samstag";
		default:
			return "UNKNOWN_DAY";
	}
}


?>

<html>
<head>
	<script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
	<script type="text/javascript">
		google.charts.load('current', { 'packages': [ 'bar', 'line' ] });
		google.charts.setOnLoadCallback(drawCharts);

		function drawCharts() {


			var dataTotal = google.visualization.arrayToDataTable([
				[ 'Stunde', 'Sommerbad', 'Hallenbad' ],
				<?php
				foreach ($totalData as $u) {
					echo "['$u[hour] Uhr', $u[avg_sommerbad], $u[avg_hallenbad]],";

				}
				?>
			]);
			var optionsTotal = {
				chart: {
					title: 'Badearena Statistik',
					subtitle: 'Besucherauslastung der letzten 3 Wochen im Durchschnitt',
					legend: { position: 'top', alignment: 'end' },
				}
			};


			var dataToday = google.visualization.arrayToDataTable([
				[ 'Datum', 'Sommerbad', 'Hallenbad' ],
				<?=implode(",", $last4h)?>
			]);
			var optionsToday = {
				chart: {
					title: 'Besucher heute',
				},
				width: 900,
				height: 500
			};


			<?php
			foreach ($daysOfWeek as $dayOfWeek) {

				echo "var dataDow$dayOfWeek[dayOfWeek] = google.visualization.arrayToDataTable([
                ['Stunde', 'Sommerbad', 'Hallenbad'],
	            " . implode("", $dayOfWeekData[$dayOfWeek["dayOfWeek"]]) . "
            ]);
            var optionsDow$dayOfWeek[dayOfWeek] = {
                chart: {
                    title: 'Statistik " . dayIntToName($dayOfWeek['dayOfWeek']) . "',
                    legend: { position: 'bottom' },
                }
            };";


			}
			?>


			var chartTotal = new google.charts.Bar(document.getElementById('columnchart_material'));
			chartTotal.draw(dataTotal, google.charts.Bar.convertOptions(optionsTotal));

			var chartLast4h = new google.charts.Line(document.getElementById('linechart_material'));
			chartLast4h.draw(dataToday, google.charts.Line.convertOptions(optionsToday));

			<?php
			foreach ($daysOfWeek as $dayOfWeek) {
				echo "
	             var chartDow$dayOfWeek[dayOfWeek] = new google.charts.Bar(document.getElementById('chart_dow$dayOfWeek[dayOfWeek]'));
                chartDow$dayOfWeek[dayOfWeek].draw(dataDow$dayOfWeek[dayOfWeek], google.charts.Bar.convertOptions(optionsDow$dayOfWeek[dayOfWeek]));
	            ";
			}
			?>


		}
	</script>
</head>
<body>

<div id="columnchart_material" style="width: 900px; height: 500px;"></div>
<div id="linechart_material" style="width: 900px; height: 500px;"></div>

<hr/>

<?php
foreach ($daysOfWeek as $dayOfWeek) {
	echo "<div id='chart_dow$dayOfWeek[dayOfWeek]' style='width: 600px; height: 400px; float: left; margin: 10px;'></div>";

}
?>


</body>
</html>
