<?php

function slugify($text)
{
	$text = str_replace(['ü', 'ö', 'ä'], ['ue', 'oe', 'ae'], $text);
	$text = preg_replace('~[^\\pL\d]+~u', '-', $text);
	$text = trim($text, '-');
	$text = iconv('utf-8', 'us-ascii//TRANSLIT', $text);
	$text = strtolower($text);
	$text = preg_replace('~[^-\w]+~', '', $text);

	if (empty($text)) {
		return 'n-a';
	}
	return $text;
}

function jsonHeader()
{
	header('Content-Type: application/json');
}

function jsonStatus($status = true, $message = "", $data = false, $header = true)
{
	if ($header) {
		header('Content-Type: application/json');
	}

	return json_encode(["status" => $status, "message" => $message, "data" => $data]);

}

function guid()
{
	if (function_exists('com_create_guid') === true) {
		return strtolower(trim(com_create_guid(), '{}'));
	}
	//return strtolower(sprintf('%04X%04X-%04X-%04X-%04X-%04X%04X%04X', mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(16384, 20479), mt_rand(32768, 49151), mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535)));
	$data = openssl_random_pseudo_bytes(16);
	$data[6] = chr(ord($data[6]) & 0x0f | 0x40); // set version to 0100
	$data[8] = chr(ord($data[8]) & 0x3f | 0x80); // set bits 6-7 to 10
	return vsprintf('%s%s-%s-%s-%s-%s%s%s', str_split(bin2hex($data), 4));
}

function is_guid($str)
{
	return preg_match('/^\{?[A-Za-z0-9]{8}-[A-Za-z0-9]{4}-[A-Za-z0-9]{4}-[A-Za-z0-9]{4}-[A-Za-z0-9]{12}\}?$/', $str);
}

function startsWith($haystack, $needle)
{
	// search backwards starting from haystack length characters from the end
	return $needle === "" || strrpos($haystack, $needle, -strlen($haystack)) !== false;
}

function endsWith($haystack, $needle)
{
	// search forward starting from end minus needle length characters
	return $needle === "" || (($temp = strlen($haystack) - strlen($needle)) >= 0 && strpos($haystack, $needle, $temp) !== false);
}

function inRange($int, $min, $max)
{
	return ($min < $int && $int < $max);
}

function castToInt($value)
{
	return ((int)$value);
}

function fixThisShit1($bundesland)
{
	switch ($bundesland) {

		case 'Wien':
			return "W";
		case 'Vorarlberg':
			return 'V';
		case 'Tirol':
			return 'T';
		case 'Steiermark':
			return 'Stmk';
		case 'Salzburg':
			return 'Sbg';
		case 'Oberösterreich':
			return 'OÖ';
		case 'Niederösterreich':
			return 'NÖ';
		case 'Kärnten':
			return 'Ktn';
		case 'Burgenland':
			return 'Bgld';

		default:
			return $bundesland;
	}

}

/**
 * @param array $array
 * @param string $key
 * @param string $value
 * @return mixed|null
 */
function array_extract_first_by_key_value(array $array, string $key, string $value)
{
	s("looking for key $key = value $value");
	foreach ($array as $a) {
		if (!isset($a[$key]))
			continue;
		if ($a[$key] == $value)
			return $a;
	}
	return null;
}